# Todo4: Condorset Task Management

## Synopsis

Todo4 is a personal task management software that runs in the terminal via a custom NodeJS repl.  It utilizes [Condorset Ranking](https://en.wikipedia.org/wiki/Condorcet_method) to track the priority and timeliness of tasks and order dependencies.  It can whittle the largests lists into a selection of the most imporant tasks so long as you use good judgement when ranking tasks.

## File structure

todo.js contains the core logic of managing tasks and their relative ranking.  data.js and data2.js manages state persistence.  nice.js is a wrapper to todo.js that provides easy to use functions for the node REPL environment including many shorthands.  easystart.js takes the functions from nice.js and places them into a REPL with its own context and makes it easy to launch specific lists as "users".

## The most important included functions

These are the functions I use most from nice.js

- pull() aka p().  Pull some sample tasks off the top of the stack.  Pulling tasks list them and provides the task id and assigns a temporary short id.
- rank() rank with full ids.
- r() rank with short ids. 
- pullmirror() aka pm(). gives you a sample of past tasks to see if you want to do them again or re-add them to the main stack
- add(). Opens up a prompt to add tasks to the top of the stack
- addfromfile(). Let's you bulk add from a file
- remove(). Removes a task from the stack.
- done(). Removes and marks done using a full id.
- d(). Mark done the task you ranked top in your last ranking or uses a short id.
- search(). Find tasks matching each pattern you provide.
- pullexposed(). Pull but only consider tasks that have ranking data
- edit(). Edit the text of a task
- lookback(). Look at what tasks you have gotten done either that day or some number of days back.